// Imitating game time ticking in Storyline
// @rabbitoreg
// v0.1
// Beta -- expect bugs

// Global variables
var gametime=0; // Ticking main game time.
var gametimepause=0; // 0 - stopped, 1 - ticking
var gametimereset=0; // 0 - no reset, 1 - reset game time
var defaultSpeed=1000; // 1 second
var currentSpeed=1000; // 1 second

var timeArrayCounter=0; // Holds secondary timers.
var timeArray= new Object;


// Usage of main tick
// startGameTime(speed) speed is in seconds, smallest is 1
// You need a Storyline variable called Tick
// resetGameTime(), pauseGameTime(), resumeGameTime()

//Usage of secondary countdown tickers
//addTicker(slvar,tick,max,recycle,completevariable)
// slvar -- Storyline varible name.
// tick -- number of ticks it will take to wait between each countdown
// max -- countdown starts, the end result is 0
// recycle -- 0 means no recycle, the countdown ends at 0. 1 means it restarts
// completevariable -- optional. The Storyline variable to call while counting (2), and when finished (1)
// pauseSticker(slvar), resumeTicker(slvar), resetTricker(slvar)

function addTicker(slvar,tick,max,recycle,completevariable)
{
	
p = GetPlayer();
if (timeArray[slvar]==null)
{	
timeArray[slvar]=new Array();
}

timeArray[slvar][0]=slvar;
timeArray[slvar][1]=tick;
timeArray[slvar][2]=gametime-tick;
timeArray[slvar][3]=0;
timeArray[slvar][5]=recycle;
timeArray[slvar][4]=parseInt(max);
timeArray[slvar][6]=0;
timeArray[slvar][7]=parseInt(max);
timeArray[slvar][8]=completevariable;

if (completevariable)
{	
p.SetVar(""+completevariable+"",2);
}
p.SetVar(""+slvar+"",timeArray[slvar][7]+2);

p.SetVar(""+slvar+"",timeArray[slvar][7]+1);

_checkTimer(timeArray[slvar]);
}

function pauseTicker(slvar)
{
timeArray[slvar][3]=1;	
}

function startTicker(slvar)
{
timeArray[slvar][3]=0;	
}

function resumeTicker(slvar)
{
timeArray[slvar][3]=0;	
}

function resetTicker(slvar)
{
timeArray[slvar][6]=0;
timeArray[slvar][3]=1;
}


//MAIN GAME TIME

function startGameTime(speed)
{
if ((parseInt(speed)<=1) || (!speed))
{
	speed = 1;
}	
currentSpeed=speed*1000;
defaultSpeed=currentSpeed;
setTimeout(function(){_gametime()}, currentSpeed); 


}

function resetGameTime()
{
gametime=0;
gametimepause=0;
}

function resumeGameTime()
{
gametimepause=0;
}

function pauseGameTime(sec)
{
var p = GetPlayer();
gametimepause=1;
p.SetVar("TickStatus",0);
if (sec>0)
{
setTimeout(function(){resumeGameTime()}, sec*1000);
}
}

function setTick(sec)
{
_setSpeed(sec*1000);
	
}

function _setSpeed(millisec)
{
currentSpeed=millisec;
}

function resetGameSpeed()
{
currentSpeed=defaultSpeed;
}




// INTERNAL TICKING FUNCTION
function _gametime()
{
	
if (gametimepause==0)
{
var p = GetPlayer();
gametime++;
p.SetVar("Tick",gametime);


for (var i in timeArray)
	{
		_checkTimer(timeArray[i])
    }
}

setTimeout(function(){_gametime()}, currentSpeed);
}

function _checkTimer(el)
{
	var p = GetPlayer();
	var currentSL=0;
	
	
if (gametime-el[2]>=el[1])
{

	if ((el[7]>0) || (el[4]==0))
	{
	
	currentSL=parseInt(p.GetVar(""+el[0]+""));
	currentSL--;
	
	p.SetVar(""+el[0]+"",currentSL);
	el[6]++;
	el[2]=gametime;
	el[7]=currentSL;
	}
	else
	{
	if (el[5]==1)
	   {
	   el[6]=0;
	   el[7]=el[4];
	   p.SetVar(""+el[0]+"",el[7]);
	   }
	  else
	  {
		p.SetVar(""+el[8]+"",1);  
	  }		  
	}
}

}